(2.10) Hotplug: rpc support
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         doc/users \
104         test/data/htools \
105         test/data/htools/rapi \
106         test/hs/shelltests \
107         test/autotools \
108         lib \
109         lib/build \
110         lib/client \
111         lib/cmdlib \
112         lib/confd \
113         lib/http \
114         lib/hypervisor \
115         lib/impexpd \
116         lib/masterd \
117         lib/rapi \
118         lib/server \
119         lib/tools \
120         lib/utils \
121         lib/watcher \
122         man \
123         qa \
124         test \
125         test/data \
126         test/data/bdev-rbd \
127         test/data/ovfdata \
128         test/data/ovfdata/other \
129         test/py \
130         tools
131
132 ALL_APIDOC_HS_DIRS = \
133         $(APIDOC_HS_DIR) \
134         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
135
136 BUILDTIME_DIR_AUTOCREATE = \
137         scripts \
138         $(APIDOC_DIR) \
139         $(ALL_APIDOC_HS_DIRS) \
140         $(APIDOC_PY_DIR) \
141         $(COVERAGE_DIR) \
142         $(COVERAGE_HS_DIR) \
143         $(COVERAGE_PY_DIR) \
144         .hpc
145
146 BUILDTIME_DIRS = \
147         $(BUILDTIME_DIR_AUTOCREATE) \
148         doc/html \
149         doc/man-html
150
151 DIRCHECK_EXCLUDE = \
152         $(BUILDTIME_DIRS) \
153         ganeti-[0-9]*.[0-9]*.[0-9]* \
154         doc/html/_* \
155         doc/man-html/_* \
156         autom4te.cache
157
158 # some helper vars
159 COVERAGE_DIR = doc/coverage
160 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
161 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
162 APIDOC_DIR = doc/api
163 APIDOC_PY_DIR = $(APIDOC_DIR)/py
164 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
165
166 MAINTAINERCLEANFILES = \
167         $(maninput) \
168         doc/install-quick.rst \
169         doc/news.rst \
170         doc/upgrade.rst \
171         vcs-version
172
173 maintainer-clean-local:
174         rm -rf $(BUILDTIME_DIRS)
175
176 CLEANFILES = \
177         $(addsuffix /*.py[co],$(DIRS)) \
178         $(addsuffix /*.hi,$(HS_DIRS)) \
179         $(addsuffix /*.o,$(HS_DIRS)) \
180         $(PYTHON_BOOTSTRAP) \
181         epydoc.conf \
182         $(REPLACE_VARS_SED) \
183         $(SHELL_ENV_INIT) \
184         daemons/daemon-util \
185         daemons/ganeti-cleaner \
186         devel/squeeze-amd64.tar.gz \
187         devel/squeeze-amd64.conf \
188         $(mandocrst) \
189         doc/manpages-enabled.rst \
190         $(BUILT_EXAMPLES) \
191         doc/examples/bash_completion \
192         doc/examples/bash_completion-debug \
193         $(userspecs) \
194         lib/_generated_rpc.py \
195         $(man_MANS) \
196         $(manhtml) \
197         tools/kvm-ifup \
198         tools/vif-ganeti \
199         tools/net-common \
200         tools/users-setup \
201         tools/vcluster-setup \
202         stamp-directories \
203         stamp-srclinks \
204         $(nodist_pkgpython_PYTHON) \
205         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
206         $(HS_BUILT_TEST_HELPERS) \
207         src/ganeti-confd \
208         src/ganeti-luxid \
209         src/ganeti-mond \
210         .hpc/*.mix src/*.tix test/hs/*.tix \
211         doc/hs-lint.html
212
213 GENERATED_FILES = \
214         $(built_base_sources) \
215         $(BUILT_PYTHON_SOURCES) \
216         $(PYTHON_BOOTSTRAP)
217
218 HS_GENERATED_FILES =
219 if WANT_HTOOLS
220 HS_GENERATED_FILES += $(HS_PROGS)
221 if ENABLE_CONFD
222 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
223 endif
224
225 if ENABLE_MOND
226 HS_GENERATED_FILES += src/ganeti-mond
227 endif
228 endif
229
230 built_base_sources = \
231         stamp-directories \
232         stamp-srclinks
233
234 built_python_base_sources = \
235         lib/_autoconf.py \
236         lib/_vcsversion.py
237
238 BUILT_PYTHON_SOURCES = \
239         $(built_python_base_sources) \
240         lib/_generated_rpc.py
241
242 # Generating the RPC wrappers depends on many things, so make sure
243 # it's built at the end of the built sources
244 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
245
246 # these are all built from the underlying %.in sources
247 BUILT_EXAMPLES = \
248         doc/examples/ganeti-kvm-poweroff.initd \
249         doc/examples/ganeti.cron \
250         doc/examples/ganeti.initd \
251         doc/examples/ganeti.logrotate \
252         doc/examples/ganeti-master-role.ocf \
253         doc/examples/ganeti-node-role.ocf \
254         doc/examples/gnt-config-backup \
255         doc/examples/hooks/ipsec
256
257 nodist_pkgpython_PYTHON = \
258         $(BUILT_PYTHON_SOURCES)
259
260 noinst_PYTHON = \
261         lib/build/__init__.py \
262         lib/build/shell_example_lexer.py \
263         lib/build/sphinx_ext.py
264
265 pkgpython_PYTHON = \
266         lib/__init__.py \
267         lib/asyncnotifier.py \
268         lib/backend.py \
269         lib/bdev.py \
270         lib/bootstrap.py \
271         lib/cli.py \
272         lib/compat.py \
273         lib/config.py \
274         lib/constants.py \
275         lib/daemon.py \
276         lib/errors.py \
277         lib/hooksmaster.py \
278         lib/ht.py \
279         lib/jqueue.py \
280         lib/jstore.py \
281         lib/locking.py \
282         lib/luxi.py \
283         lib/mcpu.py \
284         lib/netutils.py \
285         lib/objects.py \
286         lib/opcodes.py \
287         lib/outils.py \
288         lib/ovf.py \
289         lib/pathutils.py \
290         lib/qlang.py \
291         lib/query.py \
292         lib/rpc.py \
293         lib/rpc_defs.py \
294         lib/runtime.py \
295         lib/serializer.py \
296         lib/ssconf.py \
297         lib/ssh.py \
298         lib/storage.py \
299         lib/uidpool.py \
300         lib/vcluster.py \
301         lib/network.py \
302         lib/workerpool.py
303
304 client_PYTHON = \
305         lib/client/__init__.py \
306         lib/client/gnt_backup.py \
307         lib/client/gnt_cluster.py \
308         lib/client/gnt_debug.py \
309         lib/client/gnt_group.py \
310         lib/client/gnt_instance.py \
311         lib/client/gnt_job.py \
312         lib/client/gnt_node.py \
313         lib/client/gnt_network.py \
314         lib/client/gnt_os.py \
315         lib/client/gnt_storage.py
316
317 cmdlib_PYTHON = \
318         lib/cmdlib/__init__.py \
319         lib/cmdlib/backup.py \
320         lib/cmdlib/base.py \
321         lib/cmdlib/cluster.py \
322         lib/cmdlib/common.py \
323         lib/cmdlib/group.py \
324         lib/cmdlib/instance.py \
325         lib/cmdlib/instance_migration.py \
326         lib/cmdlib/instance_operation.py \
327         lib/cmdlib/instance_query.py \
328         lib/cmdlib/instance_storage.py \
329         lib/cmdlib/instance_utils.py \
330         lib/cmdlib/misc.py \
331         lib/cmdlib/network.py \
332         lib/cmdlib/node.py \
333         lib/cmdlib/operating_system.py \
334         lib/cmdlib/query.py \
335         lib/cmdlib/tags.py \
336         lib/cmdlib/test.py
337
338 hypervisor_PYTHON = \
339         lib/hypervisor/__init__.py \
340         lib/hypervisor/hv_base.py \
341         lib/hypervisor/hv_chroot.py \
342         lib/hypervisor/hv_fake.py \
343         lib/hypervisor/hv_kvm.py \
344         lib/hypervisor/hv_lxc.py \
345         lib/hypervisor/hv_xen.py
346
347 rapi_PYTHON = \
348         lib/rapi/__init__.py \
349         lib/rapi/baserlib.py \
350         lib/rapi/client.py \
351         lib/rapi/client_utils.py \
352         lib/rapi/connector.py \
353         lib/rapi/rlib2.py \
354         lib/rapi/testutils.py
355
356 http_PYTHON = \
357         lib/http/__init__.py \
358         lib/http/auth.py \
359         lib/http/client.py \
360         lib/http/server.py
361
362 confd_PYTHON = \
363         lib/confd/__init__.py \
364         lib/confd/client.py
365
366 masterd_PYTHON = \
367         lib/masterd/__init__.py \
368         lib/masterd/iallocator.py \
369         lib/masterd/instance.py
370
371 impexpd_PYTHON = \
372         lib/impexpd/__init__.py
373
374 watcher_PYTHON = \
375         lib/watcher/__init__.py \
376         lib/watcher/nodemaint.py \
377         lib/watcher/state.py
378
379 server_PYTHON = \
380         lib/server/__init__.py \
381         lib/server/masterd.py \
382         lib/server/noded.py \
383         lib/server/rapi.py
384
385 pytools_PYTHON = \
386         lib/tools/__init__.py \
387         lib/tools/burnin.py \
388         lib/tools/ensure_dirs.py \
389         lib/tools/node_cleanup.py \
390         lib/tools/node_daemon_setup.py \
391         lib/tools/prepare_node_join.py
392
393 utils_PYTHON = \
394         lib/utils/__init__.py \
395         lib/utils/algo.py \
396         lib/utils/filelock.py \
397         lib/utils/hash.py \
398         lib/utils/io.py \
399         lib/utils/log.py \
400         lib/utils/lvm.py \
401         lib/utils/mlock.py \
402         lib/utils/nodesetup.py \
403         lib/utils/process.py \
404         lib/utils/retry.py \
405         lib/utils/text.py \
406         lib/utils/wrapper.py \
407         lib/utils/x509.py
408
409 docinput = \
410         doc/conf.py \
411         doc/css/style.css \
412         doc/admin.rst \
413         doc/cluster-merge.rst \
414         doc/design-2.0.rst \
415         doc/design-2.1.rst \
416         doc/design-2.2.rst \
417         doc/design-2.3.rst \
418         doc/design-2.4.rst \
419         doc/design-2.5.rst \
420         doc/design-2.6.rst \
421         doc/design-2.7.rst \
422         doc/design-2.8.rst \
423         doc/design-autorepair.rst \
424         doc/design-bulk-create.rst \
425         doc/design-chained-jobs.rst \
426         doc/design-cpu-pinning.rst \
427         doc/design-device-uuid-name.rst \
428         doc/design-draft.rst \
429         doc/design-daemons.rst \
430         doc/design-htools-2.3.rst \
431         doc/design-http-server.rst \
432         doc/design-impexp2.rst \
433         doc/design-lu-generated-jobs.rst \
434         doc/design-linuxha.rst \
435         doc/design-multi-reloc.rst \
436         doc/design-network.rst \
437         doc/design-node-add.rst \
438         doc/design-oob.rst \
439         doc/design-ovf-support.rst \
440         doc/design-opportunistic-locking.rst \
441         doc/design-partitioned.rst \
442         doc/design-query-splitting.rst \
443         doc/design-query2.rst \
444         doc/design-reason-trail.rst \
445         doc/design-resource-model.rst \
446         doc/design-restricted-commands.rst \
447         doc/design-shared-storage.rst \
448         doc/design-monitoring-agent.rst \
449         doc/design-virtual-clusters.rst \
450         doc/design-x509-ca.rst \
451         doc/design-hroller.rst \
452         doc/design-storagetypes.rst \
453         doc/devnotes.rst \
454         doc/glossary.rst \
455         doc/hooks.rst \
456         doc/iallocator.rst \
457         doc/index.rst \
458         doc/install-quick.rst \
459         doc/install.rst \
460         doc/locking.rst \
461         doc/manpages-disabled.rst \
462         doc/monitoring-query-format.rst \
463         doc/move-instance.rst \
464         doc/news.rst \
465         doc/ovfconverter.rst \
466         doc/rapi.rst \
467         doc/security.rst \
468         doc/upgrade.rst \
469         doc/virtual-cluster.rst \
470         doc/walkthrough.rst
471
472 # Generates file names such as "doc/man-gnt-instance.rst"
473 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
474
475 # Haskell programs to be installed in $PREFIX/bin
476 HS_BIN_PROGS=src/htools
477
478 # Haskell programs to be installed in the MYEXECLIB dir
479 if ENABLE_MOND
480 HS_MYEXECLIB_PROGS=src/mon-collector
481 else
482 HS_MYEXECLIB_PROGS=
483 endif
484
485 # Haskell programs to be compiled by "make really-all"
486 HS_COMPILE_PROGS= \
487         src/ganeti-mond \
488         src/hconfd \
489         src/hluxid \
490         src/rpc-test
491
492 # All Haskell non-test programs to be compiled but not automatically installed
493 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
494
495 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
496 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
497
498 HS_ALL_PROGS = \
499         $(HS_PROGS) \
500         test/hs/hpc-htools \
501         test/hs/hpc-mon-collector \
502         test/hs/htest \
503         $(HS_COMPILE_PROGS)
504
505 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
506 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
507
508 HFLAGS = \
509         -O -Wall -Werror -isrc \
510         -fwarn-monomorphism-restriction \
511         -fwarn-tabs \
512         $(GHC_BYVERSION_FLAGS)
513
514 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
515 HEXTRA =
516 # internal extra flags (used for test/hs/htest mainly)
517 HEXTRA_INT =
518 # exclude options for coverage reports
519 HPCEXCL = --exclude Main \
520         --exclude Ganeti.Constants \
521         --exclude Ganeti.HTools.QC \
522         --exclude Ganeti.THH \
523         --exclude Ganeti.Version \
524         --exclude Test.Ganeti.Attoparsec \
525         --exclude Test.Ganeti.TestCommon \
526         --exclude Test.Ganeti.TestHTools \
527         --exclude Test.Ganeti.TestHelper \
528         --exclude Test.Ganeti.TestImports \
529         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
530
531 HS_LIB_SRCS = \
532         src/Ganeti/Block/Drbd/Types.hs \
533         src/Ganeti/Block/Drbd/Parser.hs \
534         src/Ganeti/BasicTypes.hs \
535         src/Ganeti/Common.hs \
536         src/Ganeti/Compat.hs \
537         src/Ganeti/Confd/Client.hs \
538         src/Ganeti/Confd/Server.hs \
539         src/Ganeti/Confd/Types.hs \
540         src/Ganeti/Confd/Utils.hs \
541         src/Ganeti/Config.hs \
542         src/Ganeti/ConfigReader.hs \
543         src/Ganeti/Curl/Multi.hs \
544         src/Ganeti/Daemon.hs \
545         src/Ganeti/DataCollectors/CLI.hs \
546         src/Ganeti/DataCollectors/Drbd.hs \
547         src/Ganeti/DataCollectors/Program.hs \
548         src/Ganeti/DataCollectors/Types.hs \
549         src/Ganeti/Errors.hs \
550         src/Ganeti/HTools/Backend/IAlloc.hs \
551         src/Ganeti/HTools/Backend/Luxi.hs \
552         src/Ganeti/HTools/Backend/Rapi.hs \
553         src/Ganeti/HTools/Backend/Simu.hs \
554         src/Ganeti/HTools/Backend/Text.hs \
555         src/Ganeti/HTools/CLI.hs \
556         src/Ganeti/HTools/Cluster.hs \
557         src/Ganeti/HTools/Container.hs \
558         src/Ganeti/HTools/ExtLoader.hs \
559         src/Ganeti/HTools/Graph.hs \
560         src/Ganeti/HTools/Group.hs \
561         src/Ganeti/HTools/Instance.hs \
562         src/Ganeti/HTools/Loader.hs \
563         src/Ganeti/HTools/Nic.hs \
564         src/Ganeti/HTools/Node.hs \
565         src/Ganeti/HTools/PeerMap.hs \
566         src/Ganeti/HTools/Program/Hail.hs \
567         src/Ganeti/HTools/Program/Harep.hs \
568         src/Ganeti/HTools/Program/Hbal.hs \
569         src/Ganeti/HTools/Program/Hcheck.hs \
570         src/Ganeti/HTools/Program/Hinfo.hs \
571         src/Ganeti/HTools/Program/Hscan.hs \
572         src/Ganeti/HTools/Program/Hspace.hs \
573         src/Ganeti/HTools/Program/Hroller.hs \
574         src/Ganeti/HTools/Program/Main.hs \
575         src/Ganeti/HTools/Types.hs \
576         src/Ganeti/Hypervisor/Xen/XmParser.hs \
577         src/Ganeti/Hypervisor/Xen/Types.hs \
578         src/Ganeti/Hash.hs \
579         src/Ganeti/JQueue.hs \
580         src/Ganeti/JSON.hs \
581         src/Ganeti/Jobs.hs \
582         src/Ganeti/Logging.hs \
583         src/Ganeti/Luxi.hs \
584         src/Ganeti/Monitoring/Server.hs \
585         src/Ganeti/Network.hs \
586         src/Ganeti/Objects.hs \
587         src/Ganeti/OpCodes.hs \
588         src/Ganeti/OpParams.hs \
589         src/Ganeti/Path.hs \
590         src/Ganeti/Query/Common.hs \
591         src/Ganeti/Query/Export.hs \
592         src/Ganeti/Query/Filter.hs \
593         src/Ganeti/Query/Group.hs \
594         src/Ganeti/Query/Job.hs \
595         src/Ganeti/Query/Language.hs \
596         src/Ganeti/Query/Network.hs \
597         src/Ganeti/Query/Node.hs \
598         src/Ganeti/Query/Query.hs \
599         src/Ganeti/Query/Server.hs \
600         src/Ganeti/Query/Types.hs \
601         src/Ganeti/Rpc.hs \
602         src/Ganeti/Runtime.hs \
603         src/Ganeti/Ssconf.hs \
604         src/Ganeti/THH.hs \
605         src/Ganeti/Types.hs \
606         src/Ganeti/Utils.hs
607
608 HS_TEST_SRCS = \
609         test/hs/Test/Ganeti/Attoparsec.hs \
610         test/hs/Test/Ganeti/BasicTypes.hs \
611         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
612         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
613         test/hs/Test/Ganeti/Common.hs \
614         test/hs/Test/Ganeti/Confd/Types.hs \
615         test/hs/Test/Ganeti/Confd/Utils.hs \
616         test/hs/Test/Ganeti/Daemon.hs \
617         test/hs/Test/Ganeti/Errors.hs \
618         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
619         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
620         test/hs/Test/Ganeti/HTools/CLI.hs \
621         test/hs/Test/Ganeti/HTools/Cluster.hs \
622         test/hs/Test/Ganeti/HTools/Container.hs \
623         test/hs/Test/Ganeti/HTools/Graph.hs \
624         test/hs/Test/Ganeti/HTools/Instance.hs \
625         test/hs/Test/Ganeti/HTools/Loader.hs \
626         test/hs/Test/Ganeti/HTools/Node.hs \
627         test/hs/Test/Ganeti/HTools/PeerMap.hs \
628         test/hs/Test/Ganeti/HTools/Types.hs \
629         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
630         test/hs/Test/Ganeti/JSON.hs \
631         test/hs/Test/Ganeti/Jobs.hs \
632         test/hs/Test/Ganeti/JQueue.hs \
633         test/hs/Test/Ganeti/Luxi.hs \
634         test/hs/Test/Ganeti/Network.hs \
635         test/hs/Test/Ganeti/Objects.hs \
636         test/hs/Test/Ganeti/OpCodes.hs \
637         test/hs/Test/Ganeti/Query/Filter.hs \
638         test/hs/Test/Ganeti/Query/Language.hs \
639         test/hs/Test/Ganeti/Query/Network.hs \
640         test/hs/Test/Ganeti/Query/Query.hs \
641         test/hs/Test/Ganeti/Rpc.hs \
642         test/hs/Test/Ganeti/Runtime.hs \
643         test/hs/Test/Ganeti/Ssconf.hs \
644         test/hs/Test/Ganeti/THH.hs \
645         test/hs/Test/Ganeti/TestCommon.hs \
646         test/hs/Test/Ganeti/TestHTools.hs \
647         test/hs/Test/Ganeti/TestHelper.hs \
648         test/hs/Test/Ganeti/Types.hs \
649         test/hs/Test/Ganeti/Utils.hs
650
651 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
652
653 HS_BUILT_SRCS = \
654         test/hs/Test/Ganeti/TestImports.hs \
655         src/Ganeti/Constants.hs \
656         src/Ganeti/Curl/Internal.hs \
657         src/Ganeti/Version.hs
658 HS_BUILT_SRCS_IN = \
659         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
660         src/Ganeti/Curl/Internal.hsc
661
662 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
663
664 $(RUN_IN_TEMPDIR): | stamp-directories
665
666 doc/html/index.html: ENABLE_MANPAGES =
667 doc/man-html/index.html: ENABLE_MANPAGES = 1
668 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
669
670 # Note: we use here an order-only prerequisite, as the contents of
671 # _autoconf.py are not actually influencing the html build output: it
672 # has to exist in order for the sphinx module to be loaded
673 # successfully, but we certainly don't want the docs to be rebuilt if
674 # it changes
675 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
676         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
677         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
678         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
679         | $(BUILT_PYTHON_SOURCES)
680         @test -n "$(SPHINX)" || \
681             { echo 'sphinx-build' not found during configure; exit 1; }
682 if !MANPAGES_IN_DOC
683         if test -n '$(ENABLE_MANPAGES)'; then \
684           echo 'Man pages in documentation were disabled at configure time' >&2; \
685           exit 1; \
686         fi
687 endif
688 ## Sphinx provides little control over what content should be included. Some
689 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
690 ## build two different versions of the documentation--once without man pages and
691 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
692 ## us with this, but requires running in a temporary directory. It moves the
693 ## correct files into place depending on environment variables.
694         dir=$(dir $@) && \
695         @mkdir_p@ $$dir && \
696         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
697         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
698             -d . \
699             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
700             -D release="$(PACKAGE_VERSION)" \
701             -D graphviz_dot="$(DOT)" \
702             -D enable_manpages="$(ENABLE_MANPAGES)" \
703             doc $(CURDIR)/$$dir && \
704         rm -f $$dir/.buildinfo $$dir/objects.inv
705         touch $@
706
707 doc/html: doc/html/index.html
708
709 doc/man-html: doc/man-html/index.html
710
711 doc/install-quick.rst: INSTALL
712 doc/news.rst: NEWS
713 doc/upgrade.rst: UPGRADE
714
715 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
716         set -e; \
717         { echo '.. This file is automatically updated at build time from $<.'; \
718           echo '.. Do not edit.'; \
719           echo; \
720           cat $<; \
721         } > $@
722
723 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
724         { echo '.. This file is automatically generated, do not edit!'; \
725           echo ''; \
726           echo 'Man pages'; \
727           echo '========='; \
728           echo; \
729           echo '.. toctree::'; \
730           echo '   :maxdepth: 1'; \
731           echo; \
732           for i in $(notdir $(mandocrst)); do \
733             echo "   $$i"; \
734           done | LC_ALL=C sort; \
735         } > $@
736
737 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
738 if MANPAGES_IN_DOC
739         { echo '.. This file is automatically updated at build time from $<.'; \
740           echo '.. Do not edit.'; \
741           echo; \
742           echo "$*"; \
743           echo '=========================================='; \
744           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
745         } > $@
746 else
747         echo 'Man pages in documentation were disabled at configure time' >&2; \
748         exit 1;
749 endif
750
751 doc/users/%: doc/users/%.in Makefile $(REPLACE_VARS_SED)
752         cat $< | sed -f $(REPLACE_VARS_SED) | LC_ALL=C sort | uniq | (grep -v '^root' || true) > $@
753
754 userspecs = \
755         doc/users/users \
756         doc/users/groups \
757         doc/users/groupmemberships
758
759 # Things to build but not to install (add it to EXTRA_DIST if it should be
760 # distributed)
761 noinst_DATA = \
762         $(BUILT_EXAMPLES) \
763         doc/examples/bash_completion \
764         doc/examples/bash_completion-debug \
765         $(userspecs) \
766         $(manhtml)
767
768 if HAS_SPHINX
769 if MANPAGES_IN_DOC
770 noinst_DATA += doc/man-html
771 else
772 noinst_DATA += doc/html
773 endif
774 endif
775
776 gnt_scripts = \
777         scripts/gnt-backup \
778         scripts/gnt-cluster \
779         scripts/gnt-debug \
780         scripts/gnt-group \
781         scripts/gnt-instance \
782         scripts/gnt-job \
783         scripts/gnt-network \
784         scripts/gnt-node \
785         scripts/gnt-os \
786         scripts/gnt-storage
787
788 PYTHON_BOOTSTRAP_SBIN = \
789         daemons/ganeti-masterd \
790         daemons/ganeti-noded \
791         daemons/ganeti-rapi \
792         daemons/ganeti-watcher \
793         $(gnt_scripts)
794
795 PYTHON_BOOTSTRAP = \
796         $(PYTHON_BOOTSTRAP_SBIN) \
797         tools/burnin \
798         tools/ensure-dirs \
799         tools/node-cleanup \
800         tools/node-daemon-setup \
801         tools/prepare-node-join
802
803 qa_scripts = \
804         qa/__init__.py \
805         qa/ganeti-qa.py \
806         qa/qa_cluster.py \
807         qa/qa_config.py \
808         qa/qa_daemon.py \
809         qa/qa_env.py \
810         qa/qa_error.py \
811         qa/qa_group.py \
812         qa/qa_instance.py \
813         qa/qa_job.py \
814         qa/qa_node.py \
815         qa/qa_os.py \
816         qa/qa_rapi.py \
817         qa/qa_tags.py \
818         qa/qa_utils.py
819
820 bin_SCRIPTS =
821 if WANT_HTOOLS
822 bin_SCRIPTS += $(HS_BIN_PROGS)
823 install-exec-hook:
824         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
825 # FIXME: this is a hardcoded logic, instead of auto-resolving
826         $(LN_S) -f ../../../bin/htools \
827           $(DESTDIR)$(iallocatorsdir)/hail
828         for role in $(HS_BIN_ROLES); do \
829           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
830         done
831 endif
832
833 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
834         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
835           echo "Error: cannot run unittests without the development" \
836                " libraries (see devnotes.rst)" 1>&2; \
837           exit 1; \
838         fi
839         @rm -f $(notdir $@).tix
840         $(GHC) --make \
841           $(HFLAGS) \
842           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
843           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
844           $(HEXTRA) $(HEXTRA_INT) $@
845         @touch "$@"
846
847 # for the test/hs/htest binary, we need to enable profiling/coverage
848 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
849
850 # we compile the hpc-htools binary with the program coverage
851 test/hs/hpc-htools: HEXTRA_INT=-fhpc
852
853 # we compile the hpc-mon-collector binary with the program coverage
854 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
855
856 # test dependency
857 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
858
859 # rules for building profiling-enabled versions of the haskell
860 # programs: hs-prof does the full two-step build, whereas
861 # hs-prof-quick does only the final rebuild (hs-prof must have been
862 # run before)
863 .PHONY: hs-prof hs-prof-quick
864 hs-prof:
865         @if [ -z "$(TARGET)" ]; then \
866           echo "You need to define TARGET when running this rule" 1>&2; \
867           exit 1; \
868         fi
869         $(MAKE) $(AM_MAKEFLAGS) clean
870         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
871         rm -f $(HS_ALL_PROGS)
872         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
873
874 hs-prof-quick:
875         @if [ -z "$(TARGET)" ]; then \
876           echo "You need to define TARGET when running this rule" 1>&2; \
877           exit 1; \
878         fi
879         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
880
881 dist_sbin_SCRIPTS = \
882         tools/ganeti-listrunner
883
884 nodist_sbin_SCRIPTS = \
885         $(PYTHON_BOOTSTRAP_SBIN) \
886         daemons/ganeti-cleaner
887
888 if ENABLE_CONFD
889 src/ganeti-confd: src/hconfd
890         cp -f $< $@
891
892 src/ganeti-luxid: src/hluxid
893         cp -f $< $@
894
895 nodist_sbin_SCRIPTS += src/ganeti-confd
896 nodist_sbin_SCRIPTS += src/ganeti-luxid
897 endif
898
899 if ENABLE_MOND
900 nodist_sbin_SCRIPTS += src/ganeti-mond
901 endif
902
903 python_scripts = \
904         tools/cfgshell \
905         tools/cfgupgrade \
906         tools/cfgupgrade12 \
907         tools/cluster-merge \
908         tools/confd-client \
909         tools/fmtjson \
910         tools/lvmstrap \
911         tools/move-instance \
912         tools/ovfconverter \
913         tools/sanitize-config
914
915 dist_tools_SCRIPTS = \
916         $(python_scripts) \
917         tools/burnin \
918         tools/kvm-console-wrapper \
919         tools/master-ip-setup \
920         tools/xen-console-wrapper
921
922 nodist_tools_python_scripts = \
923         tools/node-cleanup
924
925 nodist_tools_SCRIPTS = \
926         $(nodist_tools_python_scripts) \
927         tools/users-setup \
928         tools/vcluster-setup
929
930 pkglib_python_scripts = \
931         daemons/import-export \
932         tools/check-cert-expired
933
934 nodist_pkglib_python_scripts = \
935         tools/ensure-dirs \
936         tools/node-daemon-setup \
937         tools/prepare-node-join
938
939 myexeclib_SCRIPTS = \
940         daemons/daemon-util \
941         tools/kvm-ifup \
942         tools/vif-ganeti \
943         tools/net-common \
944         $(pkglib_python_scripts) \
945         $(HS_MYEXECLIB_PROGS)
946
947 nodist_myexeclib_SCRIPTS = \
948         $(nodist_pkglib_python_scripts)
949
950 EXTRA_DIST = \
951         NEWS \
952         UPGRADE \
953         epydoc.conf.in \
954         pylintrc \
955         autotools/build-bash-completion \
956         autotools/build-rpc \
957         autotools/check-header \
958         autotools/check-imports \
959         autotools/check-man-dashes \
960         autotools/check-man-references \
961         autotools/check-man-warnings \
962         autotools/check-news \
963         autotools/check-python-code \
964         autotools/check-tar \
965         autotools/check-version \
966         autotools/convert-constants \
967         autotools/docpp \
968         autotools/gen-py-coverage \
969         autotools/sphinx-wrapper \
970         autotools/testrunner \
971         autotools/wrong-hardcoded-paths \
972         $(RUN_IN_TEMPDIR) \
973         daemons/daemon-util.in \
974         daemons/ganeti-cleaner.in \
975         $(pkglib_python_scripts) \
976         devel/upload \
977         devel/webserver \
978         tools/kvm-ifup.in \
979         tools/vif-ganeti.in \
980         tools/net-common.in \
981         tools/vcluster-setup.in \
982         $(docinput) \
983         doc/html \
984         $(BUILT_EXAMPLES:%=%.in) \
985         doc/examples/ganeti.default \
986         doc/examples/ganeti.default-debug \
987         doc/examples/hooks/ethers \
988         doc/examples/gnt-debug/README \
989         doc/examples/gnt-debug/delay0.json \
990         doc/examples/gnt-debug/delay50.json \
991         doc/users/groupmemberships.in \
992         doc/users/groups.in \
993         doc/users/users.in \
994         test/py/lockperf.py \
995         test/py/testutils.py \
996         test/py/mocks.py \
997         $(dist_TESTS) \
998         $(TEST_FILES) \
999         man/footer.rst \
1000         $(manrst) \
1001         $(maninput) \
1002         qa/qa-sample.json \
1003         $(qa_scripts) \
1004         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1005         $(HS_PROG_SRCS) \
1006         src/lint-hints.hs \
1007         test/hs/cli-tests-defs.sh \
1008         test/hs/offline-test.sh \
1009         .ghci
1010
1011 man_MANS = \
1012         man/ganeti-cleaner.8 \
1013         man/ganeti-confd.8 \
1014         man/ganeti-luxid.8 \
1015         man/ganeti-listrunner.8 \
1016         man/ganeti-masterd.8 \
1017         man/ganeti-mond.8 \
1018         man/ganeti-noded.8 \
1019         man/ganeti-os-interface.7 \
1020         man/ganeti-extstorage-interface.7 \
1021         man/ganeti-rapi.8 \
1022         man/ganeti-watcher.8 \
1023         man/ganeti.7 \
1024         man/gnt-backup.8 \
1025         man/gnt-cluster.8 \
1026         man/gnt-debug.8 \
1027         man/gnt-group.8 \
1028         man/gnt-network.8 \
1029         man/gnt-instance.8 \
1030         man/gnt-job.8 \
1031         man/gnt-node.8 \
1032         man/gnt-os.8 \
1033         man/gnt-storage.8 \
1034         man/hail.1 \
1035         man/harep.1 \
1036         man/hbal.1 \
1037         man/hcheck.1 \
1038         man/hinfo.1 \
1039         man/hscan.1 \
1040         man/hspace.1 \
1041         man/hroller.1 \
1042         man/htools.1 \
1043         man/mon-collector.7
1044
1045 # Remove extensions from all filenames in man_MANS
1046 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1047
1048 manrst = $(patsubst %,%.rst,$(mannoext))
1049 manhtml = $(patsubst %.rst,%.html,$(manrst))
1050 mangen = $(patsubst %.rst,%.gen,$(manrst))
1051 maninput = \
1052         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1053         $(patsubst %.html,%.html.in,$(manhtml)) \
1054         $(mangen)
1055
1056 TEST_FILES = \
1057         test/autotools/autotools-check-news.test \
1058         test/data/htools/clean-nonzero-score.data \
1059         test/data/htools/common-suffix.data \
1060         test/data/htools/empty-cluster.data \
1061         test/data/htools/hail-alloc-drbd.json \
1062         test/data/htools/hail-alloc-invalid-network.json \
1063         test/data/htools/hail-alloc-invalid-twodisks.json \
1064         test/data/htools/hail-alloc-restricted-network.json \
1065         test/data/htools/hail-alloc-twodisks.json \
1066         test/data/htools/hail-change-group.json \
1067         test/data/htools/hail-invalid-reloc.json \
1068         test/data/htools/hail-node-evac.json \
1069         test/data/htools/hail-reloc-drbd.json \
1070         test/data/htools/hbal-excl-tags.data \
1071         test/data/htools/hbal-split-insts.data \
1072         test/data/htools/hspace-tiered-dualspec.data \
1073         test/data/htools/hspace-tiered-ipolicy.data \
1074         test/data/htools/hspace-tiered-resourcetypes.data \
1075         test/data/htools/hspace-tiered.data \
1076         test/data/htools/invalid-node.data \
1077         test/data/htools/missing-resources.data \
1078         test/data/htools/multiple-master.data \
1079         test/data/htools/n1-failure.data \
1080         test/data/htools/rapi/groups.json \
1081         test/data/htools/rapi/info.json \
1082         test/data/htools/rapi/instances.json \
1083         test/data/htools/rapi/nodes.json \
1084         test/data/htools/unique-reboot-order.data \
1085         test/hs/shelltests/htools-balancing.test \
1086         test/hs/shelltests/htools-basic.test \
1087         test/hs/shelltests/htools-dynutil.test \
1088         test/hs/shelltests/htools-excl.test \
1089         test/hs/shelltests/htools-hail.test \
1090         test/hs/shelltests/htools-hroller.test \
1091         test/hs/shelltests/htools-hspace.test \
1092         test/hs/shelltests/htools-invalid.test \
1093         test/hs/shelltests/htools-multi-group.test \
1094         test/hs/shelltests/htools-no-backend.test \
1095         test/hs/shelltests/htools-rapi.test \
1096         test/hs/shelltests/htools-single-group.test \
1097         test/hs/shelltests/htools-text-backend.test \
1098         test/hs/shelltests/htools-mon-collector.test \
1099         test/data/bdev-drbd-8.0.txt \
1100         test/data/bdev-drbd-8.3.txt \
1101         test/data/bdev-drbd-disk.txt \
1102         test/data/bdev-drbd-net-ip4.txt \
1103         test/data/bdev-drbd-net-ip6.txt \
1104         test/data/bdev-rbd/json_output_empty.txt \
1105         test/data/bdev-rbd/json_output_extra_matches.txt \
1106         test/data/bdev-rbd/json_output_no_matches.txt \
1107         test/data/bdev-rbd/json_output_ok.txt \
1108         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1109         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1110         test/data/bdev-rbd/plain_output_new_ok.txt \
1111         test/data/bdev-rbd/plain_output_old_empty.txt \
1112         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1113         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1114         test/data/bdev-rbd/plain_output_old_ok.txt \
1115         test/data/bdev-rbd/output_invalid.txt \
1116         test/data/cert1.pem \
1117         test/data/cert2.pem \
1118         test/data/cluster_config_2.7.json \
1119         test/data/cluster_config_downgraded_2.7.json \
1120         test/data/instance-minor-pairing.txt \
1121         test/data/ip-addr-show-dummy0.txt \
1122         test/data/ip-addr-show-lo-ipv4.txt \
1123         test/data/ip-addr-show-lo-ipv6.txt \
1124         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1125         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1126         test/data/ip-addr-show-lo-oneline.txt \
1127         test/data/ip-addr-show-lo.txt \
1128         test/data/kvm_0.12.5_help.txt \
1129         test/data/kvm_0.15.90_help.txt \
1130         test/data/kvm_0.9.1_help.txt \
1131         test/data/kvm_0.9.1_help_boot_test.txt \
1132         test/data/kvm_1.0_help.txt \
1133         test/data/kvm_1.1.2_help.txt \
1134         test/data/NEWS_OK.txt \
1135         test/data/NEWS_previous_unreleased.txt \
1136         test/data/ovfdata/compr_disk.vmdk.gz \
1137         test/data/ovfdata/config.ini \
1138         test/data/ovfdata/corrupted_resources.ovf \
1139         test/data/ovfdata/empty.ini \
1140         test/data/ovfdata/empty.ovf \
1141         test/data/ovfdata/ganeti.mf \
1142         test/data/ovfdata/ganeti.ovf \
1143         test/data/ovfdata/gzip_disk.ovf \
1144         test/data/ovfdata/new_disk.vmdk \
1145         test/data/ovfdata/no_disk.ini \
1146         test/data/ovfdata/no_disk_in_ref.ovf \
1147         test/data/ovfdata/no_os.ini \
1148         test/data/ovfdata/no_ovf.ova \
1149         test/data/ovfdata/other/rawdisk.raw \
1150         test/data/ovfdata/ova.ova \
1151         test/data/ovfdata/rawdisk.raw \
1152         test/data/ovfdata/second_disk.vmdk \
1153         test/data/ovfdata/unsafe_path.ini \
1154         test/data/ovfdata/virtualbox.ovf \
1155         test/data/ovfdata/wrong_config.ini \
1156         test/data/ovfdata/wrong_extension.ovd \
1157         test/data/ovfdata/wrong_manifest.mf \
1158         test/data/ovfdata/wrong_manifest.ovf \
1159         test/data/ovfdata/wrong_ova.ova \
1160         test/data/ovfdata/wrong_xml.ovf \
1161         test/data/proc_drbd8.txt \
1162         test/data/proc_drbd80-emptyline.txt \
1163         test/data/proc_drbd83.txt \
1164         test/data/proc_drbd83_sync.txt \
1165         test/data/proc_drbd83_sync_want.txt \
1166         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1167         test/data/proc_meminfo.txt \
1168         test/data/proc_cpuinfo.txt \
1169         test/data/qa-minimal-nodes-instances-only.json \
1170         test/data/sys_drbd_usermode_helper.txt \
1171         test/data/vgreduce-removemissing-2.02.02.txt \
1172         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1173         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1174         test/data/vgs-missing-pvs-2.02.02.txt \
1175         test/data/vgs-missing-pvs-2.02.66.txt \
1176         test/data/xen-xm-info-4.0.1.txt \
1177         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1178         test/data/xen-xm-list-4.0.1-four-instances.txt \
1179         test/data/xen-xm-list-long-4.0.1.txt \
1180         test/data/xen-xm-uptime-4.0.1.txt \
1181         test/py/ganeti-cli.test \
1182         test/py/gnt-cli.test \
1183         test/py/import-export_unittest-helper
1184
1185
1186 python_tests = \
1187         doc/examples/rapi_testutils.py \
1188         test/py/cfgupgrade_unittest.py \
1189         test/py/docs_unittest.py \
1190         test/py/ganeti.asyncnotifier_unittest.py \
1191         test/py/ganeti.backend_unittest-runasroot.py \
1192         test/py/ganeti.backend_unittest.py \
1193         test/py/ganeti.bdev_unittest.py \
1194         test/py/ganeti.cli_unittest.py \
1195         test/py/ganeti.client.gnt_cluster_unittest.py \
1196         test/py/ganeti.client.gnt_instance_unittest.py \
1197         test/py/ganeti.client.gnt_job_unittest.py \
1198         test/py/ganeti.cmdlib_unittest.py \
1199         test/py/ganeti.compat_unittest.py \
1200         test/py/ganeti.confd.client_unittest.py \
1201         test/py/ganeti.config_unittest.py \
1202         test/py/ganeti.constants_unittest.py \
1203         test/py/ganeti.daemon_unittest.py \
1204         test/py/ganeti.errors_unittest.py \
1205         test/py/ganeti.hooks_unittest.py \
1206         test/py/ganeti.ht_unittest.py \
1207         test/py/ganeti.http_unittest.py \
1208         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1209         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1210         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1211         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1212         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1213         test/py/ganeti.hypervisor_unittest.py \
1214         test/py/ganeti.impexpd_unittest.py \
1215         test/py/ganeti.jqueue_unittest.py \
1216         test/py/ganeti.jstore_unittest.py \
1217         test/py/ganeti.locking_unittest.py \
1218         test/py/ganeti.luxi_unittest.py \
1219         test/py/ganeti.masterd.iallocator_unittest.py \
1220         test/py/ganeti.masterd.instance_unittest.py \
1221         test/py/ganeti.mcpu_unittest.py \
1222         test/py/ganeti.netutils_unittest.py \
1223         test/py/ganeti.objects_unittest.py \
1224         test/py/ganeti.opcodes_unittest.py \
1225         test/py/ganeti.outils_unittest.py \
1226         test/py/ganeti.ovf_unittest.py \
1227         test/py/ganeti.qlang_unittest.py \
1228         test/py/ganeti.query_unittest.py \
1229         test/py/ganeti.rapi.baserlib_unittest.py \
1230         test/py/ganeti.rapi.client_unittest.py \
1231         test/py/ganeti.rapi.resources_unittest.py \
1232         test/py/ganeti.rapi.rlib2_unittest.py \
1233         test/py/ganeti.rapi.testutils_unittest.py \
1234         test/py/ganeti.rpc_unittest.py \
1235         test/py/ganeti.runtime_unittest.py \
1236         test/py/ganeti.serializer_unittest.py \
1237         test/py/ganeti.server.rapi_unittest.py \
1238         test/py/ganeti.ssconf_unittest.py \
1239         test/py/ganeti.ssh_unittest.py \
1240         test/py/ganeti.storage_unittest.py \
1241         test/py/ganeti.tools.burnin_unittest.py \
1242         test/py/ganeti.tools.ensure_dirs_unittest.py \
1243         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1244         test/py/ganeti.tools.prepare_node_join_unittest.py \
1245         test/py/ganeti.uidpool_unittest.py \
1246         test/py/ganeti.utils.algo_unittest.py \
1247         test/py/ganeti.utils.filelock_unittest.py \
1248         test/py/ganeti.utils.hash_unittest.py \
1249         test/py/ganeti.utils.io_unittest-runasroot.py \
1250         test/py/ganeti.utils.io_unittest.py \
1251         test/py/ganeti.utils.log_unittest.py \
1252         test/py/ganeti.utils.lvm_unittest.py \
1253         test/py/ganeti.utils.mlock_unittest.py \
1254         test/py/ganeti.utils.nodesetup_unittest.py \
1255         test/py/ganeti.utils.process_unittest.py \
1256         test/py/ganeti.utils.retry_unittest.py \
1257         test/py/ganeti.utils.text_unittest.py \
1258         test/py/ganeti.utils.wrapper_unittest.py \
1259         test/py/ganeti.utils.x509_unittest.py \
1260         test/py/ganeti.utils_unittest.py \
1261         test/py/ganeti.vcluster_unittest.py \
1262         test/py/ganeti.workerpool_unittest.py \
1263         test/py/pycurl_reset_unittest.py \
1264         test/py/qa.qa_config_unittest.py \
1265         test/py/tempfile_fork_unittest.py
1266
1267 haskell_tests = test/hs/htest
1268
1269 dist_TESTS = \
1270         test/py/check-cert-expired_unittest.bash \
1271         test/py/daemon-util_unittest.bash \
1272         test/py/ganeti-cleaner_unittest.bash \
1273         test/py/import-export_unittest.bash \
1274         test/py/cli-test.bash \
1275         test/py/bash_completion.bash
1276
1277 if PY_UNIT
1278 dist_TESTS += $(python_tests)
1279 endif
1280
1281 nodist_TESTS =
1282 check_SCRIPTS =
1283
1284 if WANT_HSTESTS
1285 nodist_TESTS += $(haskell_tests)
1286 dist_TESTS += test/hs/offline-test.sh
1287 check_SCRIPTS += \
1288         test/hs/hpc-htools \
1289         test/hs/hpc-mon-collector \
1290         $(HS_BUILT_TEST_HELPERS)
1291 endif
1292
1293 TESTS = $(dist_TESTS) $(nodist_TESTS)
1294
1295 # Environment for all tests
1296 PLAIN_TESTS_ENVIRONMENT = \
1297         PYTHONPATH=. \
1298         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1299         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1300         $(RUN_IN_TEMPDIR)
1301
1302 # Environment for tests run by automake
1303 TESTS_ENVIRONMENT = \
1304         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1305
1306 all_python_code = \
1307         $(dist_sbin_SCRIPTS) \
1308         $(python_scripts) \
1309         $(pkglib_python_scripts) \
1310         $(nodist_pkglib_python_scripts) \
1311         $(nodist_tools_python_scripts) \
1312         $(pkgpython_PYTHON) \
1313         $(client_PYTHON) \
1314         $(cmdlib_PYTHON) \
1315         $(hypervisor_PYTHON) \
1316         $(rapi_PYTHON) \
1317         $(server_PYTHON) \
1318         $(pytools_PYTHON) \
1319         $(http_PYTHON) \
1320         $(confd_PYTHON) \
1321         $(masterd_PYTHON) \
1322         $(impexpd_PYTHON) \
1323         $(utils_PYTHON) \
1324         $(watcher_PYTHON) \
1325         $(noinst_PYTHON) \
1326         $(qa_scripts)
1327
1328 if PY_UNIT
1329 all_python_code += $(python_tests)
1330 endif
1331
1332 srclink_files = \
1333         man/footer.rst \
1334         test/py/check-cert-expired_unittest.bash \
1335         test/py/daemon-util_unittest.bash \
1336         test/py/ganeti-cleaner_unittest.bash \
1337         test/py/import-export_unittest.bash \
1338         test/py/cli-test.bash \
1339         test/py/bash_completion.bash \
1340         test/hs/offline-test.sh \
1341         test/hs/cli-tests-defs.sh \
1342         $(all_python_code) \
1343         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1344         $(docinput)
1345
1346 check_python_code = \
1347         $(BUILD_BASH_COMPLETION) \
1348         $(CHECK_IMPORTS) \
1349         $(CHECK_HEADER) \
1350         $(DOCPP) \
1351         $(all_python_code)
1352
1353 lint_python_code = \
1354         ganeti \
1355         ganeti/http/server.py \
1356         $(dist_sbin_SCRIPTS) \
1357         $(python_scripts) \
1358         $(pkglib_python_scripts) \
1359         $(BUILD_BASH_COMPLETION) \
1360         $(CHECK_IMPORTS) \
1361         $(CHECK_HEADER) \
1362         $(DOCPP) \
1363         $(PYTHON_BOOTSTRAP)
1364
1365 standalone_python_modules = \
1366         lib/rapi/client.py \
1367         tools/ganeti-listrunner
1368
1369 pep8_python_code = \
1370         ganeti \
1371         ganeti/http/server.py \
1372         $(dist_sbin_SCRIPTS) \
1373         $(python_scripts) \
1374         $(pkglib_python_scripts) \
1375         $(BUILD_BASH_COMPLETION) \
1376         $(CHECK_HEADER) \
1377         $(DOCPP) \
1378         $(PYTHON_BOOTSTRAP) \
1379         qa
1380
1381 test/py/daemon-util_unittest.bash: daemons/daemon-util
1382
1383 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1384
1385 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1386
1387 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1388         sed -f $(REPLACE_VARS_SED) < $< > $@
1389         chmod +x $@
1390
1391 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1392         sed -f $(REPLACE_VARS_SED) < $< > $@
1393         chmod +x $@
1394
1395 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1396         sed -f $(REPLACE_VARS_SED) < $< > $@
1397         chmod +x $@
1398
1399 tools/users-setup: Makefile $(userspecs)
1400         set -e; \
1401         { echo '#!/bin/sh'; \
1402           echo 'if [ "x$$1" != "x--yes-do-it" ];'; \
1403           echo 'then echo "This will do the following changes"'; \
1404           $(AWK) -- '{print "echo + Will add group ",$$1; count++}\
1405                      END {if (count == 0) {print "echo + No groups to add"}}' doc/users/groups; \
1406           $(AWK) -- '{if (NF > 1) {print "echo + Will add user",$$1,"with primary group",$$2} \
1407                                   else {print "echo + Will add user",$$1}; count++}\
1408                      END {if (count == 0) {print "echo + No users to add"}}' doc/users/users; \
1409           $(AWK) -- '{print "echo + Will add user",$$1,"to group",$$2}' doc/users/groupmemberships; \
1410           echo 'echo'; \
1411           echo 'echo "OK? (y/n)"'; \
1412           echo 'read confirm'; \
1413           echo 'if [ "x$$confirm" != "xy" ]; then exit 0; fi'; \
1414           echo 'fi'; \
1415           $(AWK) -- '{print "addgroup --system",$$1}' doc/users/groups; \
1416           $(AWK) -- '{if (NF > 1) {print "adduser --system --ingroup",$$2,$$1} else {print "adduser --system",$$1}}' doc/users/users; \
1417           $(AWK) -- '{print "adduser",$$1,$$2}' doc/users/groupmemberships; \
1418         } > $@
1419         chmod +x $@
1420
1421 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1422         sed -f $(REPLACE_VARS_SED) < $< > $@
1423         chmod +x $@
1424
1425 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1426         sed -f $(REPLACE_VARS_SED) < $< > $@
1427         chmod +x $@
1428
1429 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1430         sed -f $(REPLACE_VARS_SED) < $< > $@
1431
1432 doc/examples/bash_completion: BC_ARGS = --compact
1433 doc/examples/bash_completion-debug: BC_ARGS =
1434
1435 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1436         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1437         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1438         daemons/ganeti-cleaner \
1439         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1440         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1441           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1442
1443 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1444         lib/build/shell_example_lexer.py \
1445         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1446         @echo "Checking $< for hardcoded paths..."
1447         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1448           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1449           exit 1; \
1450         fi
1451         set -e ; \
1452         trap 'echo auto-removing $@; rm $@' EXIT; \
1453         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1454         $(CHECK_MAN_REFERENCES) $@; \
1455         trap - EXIT
1456
1457 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1458         @test -n "$(PANDOC)" || \
1459           { echo 'pandoc' not found during configure; exit 1; }
1460         set -o pipefail -e; \
1461         trap 'echo auto-removing $@; rm $@' EXIT; \
1462         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1463           sed -e 's/\\@/@/g' > $@; \
1464         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1465         $(CHECK_MAN_DASHES) $@; \
1466         trap - EXIT
1467
1468 man/%.html.in: man/%.gen man/footer.rst
1469         @test -n "$(PANDOC)" || \
1470           { echo 'pandoc' not found during configure; exit 1; }
1471         set -o pipefail ; \
1472         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1473           sed -e 's/\\@/@/g' > $@
1474
1475 man/%: man/%.in  $(REPLACE_VARS_SED)
1476         sed -f $(REPLACE_VARS_SED) < $< > $@
1477
1478 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1479         sed -f $(REPLACE_VARS_SED) < $< > $@
1480
1481 vcs-version:
1482         if test -d .git; then \
1483           git describe > $@; \
1484         elif test ! -f $@ ; then \
1485           echo "Cannot auto-generate $@ file"; exit 1; \
1486         fi
1487
1488 .PHONY: clean-vcs-version
1489 clean-vcs-version:
1490         rm -f vcs-version
1491
1492 .PHONY: regen-vcs-version
1493 regen-vcs-version:
1494         @set -e; \
1495         cd $(srcdir); \
1496         if test -d .git; then \
1497           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1498           git describe > $$T; \
1499           if ! cmp --quiet $$T vcs-version; then \
1500             mv $$T vcs-version; \
1501           fi; \
1502         fi
1503
1504 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1505         vcs-version $(built_base_sources)
1506         set -e; \
1507         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1508         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1509
1510 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1511         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1512         lib/jstore.py $(RUN_IN_TEMPDIR) \
1513         $(CONVERT_CONSTANTS) $(built_base_sources) \
1514         | lib/_vcsversion.py
1515         set -e; \
1516         { cat $< ; \
1517           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1518         } > $@
1519
1520 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1521         hsc2hs -o $@ $<
1522
1523 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1524         $(built_base_sources)
1525         set -e; \
1526         { cat $< ; \
1527           echo ; \
1528           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1529             echo "import $$name ()" ; \
1530           done ; \
1531         } > $@
1532
1533 lib/_autoconf.py: Makefile | stamp-directories
1534         set -e; \
1535         { echo '# This file is automatically generated, do not edit!'; \
1536           echo '#'; \
1537           echo ''; \
1538           echo '"""Build-time configuration for Ganeti.'; \
1539           echo '';\
1540           echo 'This file is autogenerated by the build process.'; \
1541           echo 'For any changes you need to re-run ./configure (and'; \
1542           echo 'not edit by hand).'; \
1543           echo ''; \
1544           echo '"""'; \
1545           echo ''; \
1546           echo '# pylint: disable=C0301,C0324'; \
1547           echo '# because this is autogenerated, we do not want'; \
1548           echo '# style warnings' ; \
1549           echo ''; \
1550           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1551           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1552           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1553           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1554           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1555           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1556           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1557           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1558           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1559           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1560           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1561           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1562           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1563           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1564           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1565           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1566           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1567           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1568           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1569           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1570           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1571           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1572           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1573           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1574           echo "KVM_PATH = '$(KVM_PATH)'"; \
1575           echo "IP_PATH = '$(IP_PATH)'"; \
1576           echo "SOCAT_PATH = '$(SOCAT)'"; \
1577           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1578           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1579           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1580           echo "TOOLSDIR = '$(toolsdir)'"; \
1581           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1582           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1583           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1584           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1585           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1586           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1587           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1588           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1589           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1590           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1591           echo "RAPI_USER = '$(RAPI_USER)'"; \
1592           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1593           echo "CONFD_USER = '$(CONFD_USER)'"; \
1594           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1595           echo "LUXID_USER = '$(LUXID_USER)'"; \
1596           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1597           echo "NODED_USER = '$(NODED_USER)'"; \
1598           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1599           echo "MOND_USER = '$(MOND_USER)'"; \
1600           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1601           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1602           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1603           echo "HTOOLS = True"; \
1604           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1605           echo "XEN_CMD = '$(XEN_CMD)'"; \
1606           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1607           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1608           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1609 ## Write dictionary with man page name as the key and the section number as the
1610 ## value
1611           echo "MAN_PAGES = {"; \
1612           for i in $(notdir $(man_MANS)); do \
1613             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1614           done; \
1615           echo "}"; \
1616         } > $@
1617
1618 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1619         set -e; \
1620         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1621         { echo '# This file is automatically generated, do not edit!'; \
1622           echo '#'; \
1623           echo ''; \
1624           echo '"""Build-time VCS version number for Ganeti.'; \
1625           echo '';\
1626           echo 'This file is autogenerated by the build process.'; \
1627           echo 'For any changes you need to re-run ./configure (and'; \
1628           echo 'not edit by hand).'; \
1629           echo ''; \
1630           echo '"""'; \
1631           echo ''; \
1632           echo '# pylint: disable=C0301,C0324'; \
1633           echo '# because this is autogenerated, we do not want'; \
1634           echo '# style warnings' ; \
1635           echo ''; \
1636           echo "VCS_VERSION = '$$VCSVER'"; \
1637         } > $@
1638
1639 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1640         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1641
1642 $(SHELL_ENV_INIT): Makefile stamp-directories
1643         set -e; \
1644         { echo '# Allow overriding for tests'; \
1645           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1646           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1647           echo; \
1648           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1649           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1650           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1651           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1652           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1653         } > $@
1654
1655 ## Writes sed script to replace placeholders with build-time values. The
1656 ## additional quotes after the first @ sign are necessary to stop configure
1657 ## from replacing those values as well.
1658 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1659         set -e; \
1660         { echo 's#@''PREFIX@#$(prefix)#g'; \
1661           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1662           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1663           echo 's#@''BINDIR@#$(bindir)#g'; \
1664           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1665           echo 's#@''LIBDIR@#$(libdir)#g'; \
1666           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1667           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1668           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1669           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1670           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1671           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1672           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1673           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1674           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1675           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1676           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1677           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1678           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1679           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1680           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1681           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1682           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1683           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1684           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1685           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1686           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1687           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1688           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1689           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1690           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1691           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1692           echo; \
1693           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1694           echo '  r $(SHELL_ENV_INIT)'; \
1695           echo '  d'; \
1696           echo '}'; \
1697         } > $@
1698
1699 # Using deferred evaluation
1700 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1701 daemons/ganeti-watcher: MODULE = ganeti.watcher
1702 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1703 tools/burnin: MODULE = ganeti.tools.burnin
1704 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1705 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1706 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1707 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1708 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1709
1710 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1711         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1712         set -e; \
1713         { echo '#!/usr/bin/python'; \
1714           echo '# This file is automatically generated, do not edit!'; \
1715           echo "# Edit $(MODULE) instead."; \
1716           echo; \
1717           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1718           echo; \
1719           echo '# pylint: disable=C0103'; \
1720           echo '# C0103: Invalid name'; \
1721           echo; \
1722           echo 'import sys'; \
1723           echo 'import $(MODULE) as main'; \
1724           echo; \
1725           echo '# Temporarily alias commands until bash completion'; \
1726           echo '# generator is changed'; \
1727           echo 'if hasattr(main, "commands"):'; \
1728           echo '  commands = main.commands # pylint: disable=E1101'; \
1729           echo 'if hasattr(main, "aliases"):'; \
1730           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1731           echo; \
1732           echo 'if __name__ == "__main__":'; \
1733           echo '  sys.exit(main.Main())'; \
1734         } > $@
1735         chmod u+x $@
1736
1737 $(HS_BUILT_TEST_HELPERS): Makefile
1738         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1739         set -e; \
1740         { echo '#!/bin/sh'; \
1741           echo '# This file is automatically generated, do not edit!'; \
1742           echo "# Edit Makefile.am instead."; \
1743           echo; \
1744           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1745         } > $@
1746         chmod u+x $@
1747
1748 stamp-directories: Makefile
1749         $(MAKE) $(AM_MAKEFLAGS) ganeti
1750         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1751         touch $@
1752
1753 # We need to create symlinks because "make distcheck" will not install Python
1754 # files when building.
1755 stamp-srclinks: Makefile | stamp-directories
1756         set -e; \
1757         for i in $(srclink_files); do \
1758           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1759             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1760           fi; \
1761         done
1762         touch $@
1763
1764 .PHONY: ganeti
1765 ganeti:
1766         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1767
1768 .PHONY: check-dirs
1769 check-dirs: $(GENERATED_FILES)
1770         @set -e; \
1771         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1772           error=; \
1773           while read dir; do \
1774             case "$$dir" in \
1775               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1776               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1777             esac; \
1778           done; \
1779           for dir in $(DIRS); do \
1780             if ! test -d "$$dir"; then \
1781               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1782               error=1; \
1783             fi \
1784           done; \
1785           test -z "$$error"; \
1786         }
1787
1788 .PHONY: check-local
1789 check-local: check-dirs $(GENERATED_FILES)
1790         $(CHECK_PYTHON_CODE) $(check_python_code)
1791         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1792         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1793         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1794         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1795         error= ; \
1796         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1797           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1798           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1799             echo "Incorrect version in README, expected $$expver" >&2; \
1800             error=1; \
1801           fi; \
1802           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1803               doc/security.rst; do \
1804             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1805               "Documents Ganeti version $$expver"; then \
1806               echo "Incorrect version in $$file, expected $$expver" >&2; \
1807               error=1; \
1808             fi; \
1809           done; \
1810           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1811             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1812             error=1; \
1813           fi; \
1814           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1815             ".. Last updated for Ganeti $$expver"; then \
1816             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1817             error=1; \
1818           fi; \
1819         fi; \
1820         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1821           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1822             echo "Longest line in $$file is longer than 80 characters" >&2; \
1823             error=1; \
1824           fi; \
1825         done; \
1826         test -z "$$error"
1827
1828 .PHONY: hs-tests
1829 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1830         @rm -f htest.tix
1831         ./test/hs/htest
1832
1833 .PHONY: hs-shell
1834 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1835         @rm -f hpc-htools.tix hpc-mon-collector.tix
1836         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1837
1838 .PHONY: hs-check
1839 hs-check: hs-tests hs-shell
1840
1841 # E111: indentation is not a multiple of four
1842 # E121: continuation line indentation is not a multiple of four
1843 #       (since our indent level is not 4)
1844 # E125: continuation line does not distinguish itself from next logical line
1845 #       (since our indent level is not 4)
1846 # E127: continuation line over-indented for visual indent
1847 #       (since our indent level is not 4)
1848 # note: do NOT add E128 here; it's a valid style error in most cases!
1849 # I've seen real errors, but also some cases were we indent wrongly
1850 # due to line length; try to rework the cases where it is triggered,
1851 # instead of silencing it
1852 # E261: at least two spaces before inline comment
1853 # E501: line too long (80 characters)
1854 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1855
1856 # For excluding pep8 expects filenames only, not whole paths
1857 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1858
1859 LINT_TARGETS = pylint pylint-qa
1860 if HAS_PEP8
1861 LINT_TARGETS += pep8
1862 endif
1863 if HAS_HLINT
1864 LINT_TARGETS += hlint
1865 endif
1866
1867 .PHONY: lint
1868 lint: $(LINT_TARGETS)
1869
1870 .PHONY: pylint
1871 pylint: $(GENERATED_FILES)
1872         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1873         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1874
1875 .PHONY: pylint-qa
1876 pylint-qa: $(GENERATED_FILES)
1877         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1878         cd $(top_srcdir)/qa && \
1879           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1880           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1881
1882 .PHONY: pep8
1883 pep8: $(GENERATED_FILES)
1884         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1885         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1886           --repeat $(pep8_python_code)
1887
1888 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1889 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1890 .PHONY: hlint
1891 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1892         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1893         @rm -f doc/hs-lint.html
1894         if tty -s; then C="-c"; else C=""; fi; \
1895         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1896           --ignore "Use first" \
1897           --ignore "Use &&&" \
1898           --ignore "Use void" \
1899           --ignore "Reduce duplication" \
1900           --hint src/lint-hints \
1901           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1902         @if [ ! -f doc/hs-lint.html ]; then \
1903           echo "All good" > doc/hs-lint.html; \
1904         fi
1905
1906 # a dist hook rule for updating the vcs-version file; this is
1907 # hardcoded due to where it needs to build the file...
1908 dist-hook:
1909         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1910         rm -f $(top_distdir)/vcs-version
1911         cp -p $(srcdir)/vcs-version $(top_distdir)
1912
1913 # a distcheck hook rule for catching revision control directories
1914 distcheck-hook:
1915         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1916           echo "Found revision control files in final archive." 1>&2; \
1917           exit 1; \
1918         fi
1919         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1920           echo "Found Python byte code in final archive." 1>&2; \
1921           exit 1; \
1922         fi
1923         if find $(top_distdir) -name '*~' | grep .; then \
1924           echo "Found backup files in final archive." 1>&2; \
1925           exit 1; \
1926         fi
1927 # Empty files or directories should not be distributed. They can cause
1928 # unnecessary warnings for packagers. Directories used by automake during
1929 # distcheck must be excluded.
1930         if find $(top_distdir) -empty -and -not \( \
1931             -path $(top_distdir)/_build -or \
1932             -path $(top_distdir)/_inst \) | grep .; then \
1933           echo "Found empty files or directories in final archive." 1>&2; \
1934           exit 1; \
1935         fi
1936         if test -e $(top_distdir)/doc/man-html; then \
1937           echo "Found documentation including man pages in final archive" >&2; \
1938           exit 1; \
1939         fi
1940
1941 # Backwards compatible distcheck-release target
1942 distcheck-release: distcheck
1943
1944 distrebuildcheck: dist
1945         set -e; \
1946         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1947         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1948         cd $$builddir; \
1949         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1950         cd $(distdir); \
1951         ./configure; \
1952         $(MAKE) maintainer-clean; \
1953         cp $(abs_srcdir)/vcs-version .; \
1954         ./configure; \
1955         $(MAKE) $(AM_MAKEFLAGS)
1956
1957 dist-release: dist
1958         set -e; \
1959         for i in $(DIST_ARCHIVES); do \
1960           echo -n "Checking $$i ... "; \
1961           autotools/check-tar < $$i; \
1962           echo OK; \
1963         done
1964
1965 install-exec-local:
1966         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1967           "$(DESTDIR)${localstatedir}/log/ganeti" \
1968           "$(DESTDIR)${localstatedir}/run/ganeti"
1969
1970 .PHONY: apidoc
1971 if WANT_HSAPIDOC
1972 apidoc: py-apidoc hs-apidoc
1973 else
1974 apidoc: py-apidoc
1975 endif
1976
1977 .PHONY: py-apidoc
1978 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1979         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1980         $(RUN_IN_TEMPDIR) epydoc -v \
1981           --conf $(CURDIR)/epydoc.conf \
1982           --output $(CURDIR)/$(APIDOC_PY_DIR)
1983
1984 .PHONY: hs-apidoc
1985 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1986
1987 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1988         @test -n "$(HSCOLOUR)" || \
1989             { echo 'HsColour' not found during configure; exit 1; }
1990         @test -n "$(HADDOCK)" || \
1991             { echo 'haddock' not found during configure; exit 1; }
1992         rm -rf $(APIDOC_HS_DIR)/*
1993         for i in $(ALL_APIDOC_HS_DIRS); do \
1994           @mkdir_p@ $$i; \
1995           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1996         done
1997         set -e ; \
1998         export LC_ALL=en_US.UTF-8; \
1999         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2000         if [ "$(HS_PARALLEL3)" ]; \
2001         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2002         fi; \
2003         if [ "$(HS_REGEX_PCRE)" ]; \
2004         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2005         fi; \
2006         for file in $(HS_LIBTESTBUILT_SRCS); do \
2007           f_nosrc=$${file##src/}; \
2008           f_notst=$${f_nosrc##test/hs/}; \
2009           f_html=$${f_notst%%.hs}.html; \
2010           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2011         done ; \
2012         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2013           -t ganeti -p src/haddock-prologue \
2014           --source-module="%{MODULE/.//}.html" \
2015           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2016           $$OPTGHC \
2017           $(HS_LIBTESTBUILT_SRCS)
2018
2019 .PHONY: TAGS
2020 TAGS: $(GENERATED_FILES)
2021         rm -f TAGS
2022         $(GHC) -e ":etags" -v0 \
2023           $(filter-out -O -Werror,$(HFLAGS)) \
2024           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2025           $(HS_LIBTEST_SRCS)
2026         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2027           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2028           -path './qa/*.py' | \
2029           etags -l python -a -
2030
2031 .PHONY: coverage
2032
2033 COVERAGE_TESTS=
2034 if WANT_HTOOLS
2035 COVERAGE_TESTS += hs-coverage
2036 endif
2037 if PY_UNIT
2038 COVERAGE_TESTS += py-coverage
2039 endif
2040
2041 coverage: $(COVERAGE_TESTS)
2042
2043 .PHONY: py-coverage
2044 py-coverage: $(GENERATED_FILES) $(python_tests)
2045         @test -n "$(PYCOVERAGE)" || \
2046             { echo 'python-coverage' not found during configure; exit 1; }
2047         set -e; \
2048         COVERAGE=$(PYCOVERAGE) \
2049         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2050         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2051         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2052         $(PLAIN_TESTS_ENVIRONMENT) \
2053         $(abs_top_srcdir)/autotools/gen-py-coverage \
2054         $(python_tests)
2055
2056 .PHONY: hs-coverage
2057 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2058         rm -f *.tix
2059         $(MAKE) $(AM_MAKEFLAGS) hs-check
2060         @mkdir_p@ $(COVERAGE_HS_DIR)
2061         hpc sum --union $(HPCEXCL) \
2062           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2063         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2064         hpc report coverage-hs.tix
2065         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2066
2067 # Special "kind-of-QA" target for htools, needs special setup (all
2068 # tools compiled with -fhpc)
2069 .PHONY: live-test
2070 live-test: all
2071         set -e ; \
2072         cd src; \
2073         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2074         rm -f *.tix *.mix; \
2075         ./live-test.sh; \
2076         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2077           --output=live-test.tix ; \
2078         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2079         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2080           --srcdir=.. $(HPCEXCL) ; \
2081         hpc report --srcdir=.. live-test $(HPCEXCL)
2082
2083 commit-check: autotools-check distcheck lint apidoc
2084
2085 autotools-check:
2086         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2087   $(abs_top_srcdir)/test/autotools/*-*.test \
2088   -- --hide-successes
2089
2090 .PHONY: gitignore-check
2091 gitignore-check:
2092         @if [ -n "`git status --short`" ]; then \
2093           echo "Git status is not clean!" 1>&2 ; \
2094           git status --short; \
2095           exit 1; \
2096         fi
2097
2098 # target to rebuild all man pages (both groff and html output)
2099 .PHONY: man
2100 man: $(man_MANS) $(manhtml)
2101
2102 # Target that builds all binaries (including those that are not
2103 # rebuilt except when running the tests)
2104 .PHONY: really-all
2105 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2106
2107 # we don't need the ancient implicit rules:
2108 %: %,v
2109 %: RCS/%,v
2110 %: RCS/%
2111 %: s.%
2112 %: SCCS/s.%
2113
2114 -include ./Makefile.local
2115
2116 # vim: set noet :